#!/bin/bash

echo fastscore connect https://localhost:8000 -wait
fastscore connect https://localhost:8000
echo fastscore config set config.yaml -wait
fastscore config set config.yaml
echo fastscore fleet
fastscore fleet -wait

# Add models
fastscore model add -type:python3 tf_sp500_lstm tf_sp500_lstm.py
fastscore attachment upload tf_sp500_lstm attachment.tar.gz

fastscore model add preprocessor preprocessor.R
fastscore model add postprocessor postprocessor.py

# Add streams
fastscore stream add rest rest.json

# Add schemas
fastscore schema add double double.avsc
fastscore schema add cpi cpi.avsc
fastscore schema add sp500 sp500.avsc
fastscore schema add adjustment adjustment.avsc
